/* race condition with shared memory */

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <time.h>


int main(void)
{
  int  shmid, *shmptr;
  pid_t pid;
  int status;
  int i,tmp;

  /* request shared mem */
  shmid=shmget(IPC_PRIVATE,sizeof(int),SHM_R | SHM_W);
  printf("Shared memory id: %d\n",shmid);
  /* attach a ptr to shm */
  shmptr=(int *)shmat(shmid,0,0);
  *shmptr=0;
  printf("start: %d\n",*shmptr);
  /* detach a ptr from shm */
  shmdt(shmptr);

  for (i=0; i<20; i++) {
    pid=fork();
    if (pid==0){
      /* child code */
      shmptr=(int *)shmat(shmid,0,0);
      srand(getpid()+time(0));
      sleep(rand()%3);
      tmp=*shmptr;
      sleep(rand()%3);
      printf("child: %d\n",tmp);
      *shmptr=++tmp;
      shmdt(shmptr);
      return(0);
    }
  }

  while (wait(&status)!=-1);

  shmptr=(int *)shmat(shmid,0,0);
  printf("stop: %d\n",*shmptr);
  shmdt(shmptr);
  /* remove shared mem */
  shmctl(shmid,IPC_RMID,0);
  return 0;
}
